package com.ruoyi.file.controller;

import com.ruoyi.common.core.domain.R;
import com.ruoyi.file.service.FileUploadResponse;
import com.ruoyi.file.domain.FilesUpload;
import com.ruoyi.file.service.FilesService;
import com.usky.common.core.bean.ApiResult;
import com.usky.common.core.bean.CommonPage;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.time.LocalDateTime;


@RestController
//@RequestMapping("/files")
public class FilesController {

    @Autowired
    private FilesService filesService;

    @PostMapping("/upload")
    public ApiResult<FileUploadResponse> upload(@RequestParam MultipartFile file) {
        // 获取上传文件
        FileUploadResponse response = filesService.upload(file);
        return ApiResult.success(response);
    }


    @DeleteMapping("/delete/{id}")
    public ApiResult<String> delete(@PathVariable Integer id) {
        try {
            filesService.deleteFile(id);
            return ApiResult.success("删除成功");
        } catch (Exception e) {
            return ApiResult.error("删除失败"); // 删除失败，返回错误信息
        }
    }

    @GetMapping("/query")
    public R<CommonPage<FilesUpload>> queryFiles(
            @RequestParam(required = false) String filesName,
            @RequestParam(required = false) LocalDateTime startTime,
            @RequestParam(required = false) LocalDateTime endTime,
            @RequestParam(required = false) Boolean isDeleted,
            @RequestParam(required = false) String fileType,
            @RequestParam int current,
            @RequestParam int size) {

        // 调用服务层方法
        CommonPage<FilesUpload> resultPage = filesService.queryFiles(filesName, startTime, endTime, isDeleted, fileType, current, size);

        // 返回封装好的分页结果
        return R.ok(resultPage);
    }
}